﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data;
using System.Linq;
using System.Data.SqlClient;

namespace DataGridView_Delete_CheckBox
{
    public partial class Form1 : Form
    {
        private const string ConnectionString = @"Data Source=.\SQL2008R2;Initial Catalog=AjaxSamples;Integrated Security = true";
        public Form1()
        {
            InitializeComponent();

            //Set Columns Count
            dataGridView1.ColumnCount = 3;

            //Hide the last blank line
            dataGridView1.AllowUserToAddRows = false;

            //Add Columns
            dataGridView1.Columns[0].Name = "CustomerId";
            dataGridView1.Columns[0].HeaderText = "CustomerId Id";
            dataGridView1.Columns[0].DataPropertyName = "CustomerId";
            dataGridView1.Columns[0].Width = 100;

            dataGridView1.Columns[1].HeaderText = "Name";
            dataGridView1.Columns[1].Name = "Name";
            dataGridView1.Columns[1].DataPropertyName = "Name";
            dataGridView1.Columns[1].Width = 100;

            dataGridView1.Columns[2].Name = "Country";
            dataGridView1.Columns[2].HeaderText = "Country";
            dataGridView1.Columns[2].DataPropertyName = "Country";
            dataGridView1.Columns[2].Width = 100;

            DataGridViewCheckBoxColumn checkBoxColumn = new DataGridViewCheckBoxColumn();
            checkBoxColumn.HeaderText = "";
            checkBoxColumn.Width = 30;
            checkBoxColumn.Name = "checkBoxColumn";
            dataGridView1.Columns.Insert(0, checkBoxColumn);

            this.BindGrid();
        }

        private void BindGrid()
        {
            dataGridView1.DataSource = null;
            using (SqlConnection con = new SqlConnection(ConnectionString))
            {
                using (SqlCommand cmd = new SqlCommand("SELECT CustomerId, Name, Country FROM Customers", con))
                {
                    cmd.CommandType = CommandType.Text;
                    using (SqlDataAdapter sda = new SqlDataAdapter(cmd))
                    {
                        using (DataTable dt = new DataTable())
                        {
                            sda.Fill(dt);
                            dataGridView1.DataSource = dt;
                        }
                    }
                }
            }
        }

private void btnDelete_Click(object sender, EventArgs e)
{
    List<DataGridViewRow> selectedRows = (from row in dataGridView1.Rows.Cast<DataGridViewRow>()
                                            where Convert.ToBoolean(row.Cells["checkBoxColumn"].Value) == true
                                            select row).ToList();
    if (MessageBox.Show(string.Format("Do you want to delete {0} rows?", selectedRows.Count), "Confirmation", MessageBoxButtons.YesNo) == DialogResult.Yes)
    {
        foreach (DataGridViewRow row in selectedRows)
        {
            using (SqlConnection con = new SqlConnection(ConnectionString))
            {
                using (SqlCommand cmd = new SqlCommand("DELETE FROM Customers WHERE CustomerId = @CustomerId", con))
                {
                    cmd.CommandType = CommandType.Text;
                    cmd.Parameters.AddWithValue("@CustomerId", row.Cells["CustomerId"].Value);
                    con.Open();
                    cmd.ExecuteNonQuery();
                    con.Close();
                }
            }
        }

        this.BindGrid();
    }
}
    }
}
